#pragma once
#ifndef WRAPPER_DLL_H
#define WRAPPER_DLL_H

//һ־Ǹ߱__cplusplus(cppļ
#ifdef __cplusplus
//ΪcppļĬ϶˸ú),CԷʽб
extern "C" { 
#endif


#ifdef WRAPPER_DLL_EXPORTS  
#define WRAPPER_API __declspec(dllexport) //    
#else  
#define WRAPPER_API __declspec(dllimport) //   
#endif  

	/// <summary>
	/// ͷĿDLLļ
	/// </summary>
	WRAPPER_API void __stdcall UnloadTargetDll();
	/// <summary>
	/// 豸ͨѶ
	/// </summary>
	/// <param name="devPort">豸˿</param>
	/// <returns></returns>
	WRAPPER_API int __stdcall OpenComm(const char* devPort);
	/// <summary>
	/// ر豸ͨѶ
	/// </summary>
	/// <returns></returns>
	WRAPPER_API int __stdcall CloseComm();
	/// <summary>
	/// ICƬϵ
	/// </summary>
	/// <param name="receData">( 256 ֽ)</param>
	/// <param name="receDataLen">ݳ</param>
	/// <returns></returns>
	WRAPPER_API int __stdcall PowerOn(char* receData, unsigned long* receDataLen);
	/// <summary>
	/// ICƬµ
	/// </summary>
	/// <param name="receData">( 256 ֽ)</param>
	/// <param name="receDataLen">ݳ</param>
	/// <returns></returns>
	WRAPPER_API int __stdcall PowerOff(char* receData, unsigned long* receDataLen);
	/// <summary>
	/// ȡƬ
	/// </summary>
	/// <param name="zone">ָȡĿƬ</param>
	/// <param name="addr">ʼַ</param>
	/// <param name="len">Ҫȡݳ</param>
	/// <param name="receData">( 256 ֽ)</param>
	/// <param name="receDataLen">ݳ</param>
	/// <returns></returns>
	WRAPPER_API int __stdcall ReadCard(unsigned int zone, unsigned int addr, unsigned int len, char* receData, unsigned long* receDataLen);
	/// <summary>
	/// д뿨Ƭ
	/// </summary>
	/// <param name="zone">ָдĿƬ</param>
	/// <param name="addr">ʼַ</param>
	/// <param name="len">Ҫдݳ</param>
	/// <param name="sendData"></param>
	/// <param name="receData">( 256 ֽ)</param>
	/// <param name="receDataLen">ݳ</param>
	/// <returns></returns>
	WRAPPER_API int __stdcall WriteCard(unsigned int zone, unsigned int addr, unsigned int len, const char* sendData, char* receData, unsigned long* receDataLen);
	/// <summary>
	/// УԿ
	/// </summary>
	/// <param name="keyType">Կ</param>
	/// <param name="key">Կ</param>
	/// <param name="receData">( 256 ֽ)</param>
	/// <param name="receDataLen">ݳ</param>
	/// <returns></returns>
	WRAPPER_API int __stdcall ChkSecret(int keyType, char* key, char* receData, unsigned long* receDataLen);
	/// <summary>
	/// дԿ
	/// </summary>
	/// <param name="keyType">Կ</param>
	/// <param name="key">Կ</param>
	/// <param name="receData">( 256 ֽ)</param>
	/// <param name="receDataLen">ݳ</param>
	/// <returns></returns>
	WRAPPER_API int __stdcall WriteSecret(int keyType, char* key, char* receData, unsigned long* receDataLen);
	/// <summary>
	/// ȡԿ
	/// </summary>
	/// <param name="keyType">Կ</param>
	/// <param name="receData">( 256 ֽ)</param>
	/// <param name="receDataLen">ݳ</param>
	/// <returns></returns>
	WRAPPER_API int __stdcall ReadSecret(int keyType, char* receData, unsigned long* receDataLen);
	/// <summary>
	/// ʮַתΪֽ
	/// </summary>
	/// <param name="strData">ʮַ</param>
	/// <param name="data">תֽ</param>
	/// <returns></returns>
	WRAPPER_API int __stdcall HexStrToByte(const char* strData, char* byteData);
	/// <summary>
	/// ֽתΪʮַ
	/// </summary>
	/// <param name="byteData">ֽ</param>
	/// <param name="byteDataLen">鳤</param>
	/// <param name="strData">תʮַ</param>
	/// <returns></returns>
	WRAPPER_API int __stdcall ByteToHexStr(char* byteData, unsigned int byteDataLen, char* strData);
	/// <summary>
	/// ʮֽתΪʮ
	/// </summary>
	/// <param name="byteData">ʮַ</param>
	/// <param name="dec">תʮָ</param>
	/// <returns></returns>
	WRAPPER_API int __stdcall HexByteToDec(const char* byteData, unsigned long* dec);
	/// <summary>
	/// ʮתΪʮֽ
	/// </summary>
	/// <param name="dec">ʮ</param>
	/// <param name="byteData">תʮֽ</param>
	/// <returns></returns>
	WRAPPER_API int __stdcall DecToHexByte(unsigned long dec, char* byteData);
	/// <summary>
	/// Կ汾
	/// </summary>
	/// <param name="keyKind">Կ</param>
	/// <param name="keyVer">Կ汾</param>
	/// <param name="receData">( 256 ֽ)</param>
	/// <param name="receDataLen">ݳ</param>
	/// <returns></returns>
	WRAPPER_API int __stdcall SetKeyVersion(int keyKind, int keyVer, char* receData, unsigned long* receDataLen);
	/// <summary>
	/// У1608Կ
	/// </summary>
	/// <param name="keyNo">Կ</param>
	/// <param name="receData">( 256 ֽ)</param>
	/// <param name="receDataLen">ݳ</param>
	/// <returns></returns>
	WRAPPER_API int __stdcall Chk1608Secret(int keyNo, char* receData, unsigned long* receDataLen);
	/// <summary>
	/// ֤1608
	/// </summary>
	/// <param name="receData">( 256 ֽ)</param>
	/// <param name="receDataLen">ݳ</param>
	/// <returns></returns>
	WRAPPER_API int __stdcall Authenfic1608(char* receData, unsigned long* receDataLen);
	/// <summary>
	/// ʮַתΪ޷ųֵ
	/// </summary>
	/// <param name="byteData">ʮֽ</param>
	/// <param name="dec">ת޷ϳ</param>
	/// <returns></returns>
	WRAPPER_API int __stdcall HexByteToLong(const char* byteData, unsigned long* dec);
	/// <summary>
	/// ޷ųֵתΪʮֽ
	/// </summary>
	/// <param name="dec">޷ϳ</param>
	/// <param name="byteData">תʮֽ</param>
	/// <returns></returns>
	WRAPPER_API int __stdcall LongToHexByte(unsigned long dec, char* byteData);
	/// <summary>
	/// ǩ
	/// </summary>
	/// <param name="idInfo">ʶϢ</param>
	/// <param name="data"></param>
	/// <param name="dataLen">ݳ</param>
	/// <param name="receData">( 256 ֽ)</param>
	/// <param name="receDataLen">ݳ</param>
	/// <returns></returns>
	WRAPPER_API int __stdcall Signature(const char* idInfo, const char* data, int dataLen, char* receData, unsigned long* receDataLen);
	/// <summary>
	/// ֤ǩ
	/// </summary>
	/// <param name="idInfo">ʶϢ</param>
	/// <param name="data"></param>
	/// <param name="dataLen">ݳ</param>
	/// <param name="signInfo">ǩϢ</param>
	/// <param name="receData">( 256 ֽ)</param>
	/// <param name="receDataLen">ݳ</param>
	/// <returns></returns>
	WRAPPER_API int __stdcall VerifySignet(const char* idInfo, const char* data, int dataLen, const char* signInfo, char* receData, unsigned long* receDataLen);
	/// <summary>
	/// дʶϢ
	/// </summary>
	/// <param name="idInfo">ʶϢ</param>
	/// <param name="receData">( 256 ֽ)</param>
	/// <param name="receDataLen">ݳ</param>
	/// <returns></returns>
	WRAPPER_API int __stdcall WriteIDInfo(const char* idInfo, char* receData, unsigned long* receDataLen);
	/// <summary>
	/// PIN
	/// </summary>
	/// <param name="iopType"></param>
	/// <param name="slot">Ŀ豸</param>
	/// <param name="pinData"> PIN </param>
	/// <param name="pinDataLen"> PIN ݳ</param>
	/// <param name="receData">( 256 ֽ)</param>
	/// <param name="receDataLen">ݳ</param>
	/// <returns></returns>
	WRAPPER_API int __stdcall PINOpfunc(int iopType, int slot, const char* pinData, int pinDataLen, char* receData, unsigned long* receDataLen);
	/// <summary>
	/// ±ʶϢ
	/// </summary>
	/// <param name="idInfo">ʶϢ</param>
	/// <param name="receData">( 256 ֽ)</param>
	/// <param name="receDataLen">ݳ</param>
	/// <returns></returns>
	WRAPPER_API int __stdcall UpdateIDInfo(const char* idInfo, char* receData, unsigned long* receDataLen);
	/// <summary>
	/// û
	/// </summary>
	/// <param name="receData">( 256 ֽ)</param>
	/// <param name="receDataLen">ݳ</param>
	/// <returns></returns>
	WRAPPER_API int __stdcall LockUserCard(char* receData, unsigned long* receDataLen);
	/// <summary>
	/// ȡ SAM ʶϢ
	/// </summary>
	/// <param name="receData">( 256 ֽ)</param>
	/// <param name="receDataLen">ݳ</param>
	/// <returns></returns>
	WRAPPER_API int __stdcall ReadSamIDInfo(char* receData, unsigned long* receDataLen);
	/// <summary>
	/// ȡICƬ
	/// </summary>
	/// <param name="slot">Ŀ</param>
	/// <param name="receData">( 256 ֽ)</param>
	/// <param name="receDataLen">ݳ</param>
	/// <returns></returns>
	WRAPPER_API int __stdcall GetICCardNo(int slot, char* receData, unsigned long* receDataLen);
	/// <summary>
	/// SAMϵ
	/// </summary>
	/// <param name="receData">( 256 ֽ)</param>
	/// <param name="receDataLen">ݳ</param>
	/// <returns></returns>
	WRAPPER_API int __stdcall PowerOnSam(char* receData, unsigned long* receDataLen);
	/// <summary>
	/// GetUpdateIDRight
	/// </summary>
	/// <param name="icCardNo">IC</param>
	/// <param name="hospitalId">ҽԺ</param>
	/// <param name="receData">( 256 ֽ)</param>
	/// <param name="receDataLen">ݳ</param>
	/// <returns></returns>
	WRAPPER_API int __stdcall GetUpdateIDRight(const char* icCardNo, const char* hospital, char* receData, unsigned long* receDataLen);

#ifdef __cplusplus
}
#endif

#endif // !WRAPPER_DLL_H
