#ifndef LOGGER_H
#define LOGGER_H

#include <spdlog/spdlog.h>
#include <spdlog/sinks/daily_file_sink.h>
#include <string>
#include <memory>
#include <filesystem>

// ־
class Logger {
public:
    // ȡ־ʵ
    static std::shared_ptr<spdlog::logger> getLogger();

    // ־Ĭ INFO
    static void setLogLevel(spdlog::level::level_enum level);

    // ȷ־Ŀ¼
    static void ensureLogDir(const std::string& dir);

private:
    static std::shared_ptr<spdlog::logger> logger; // ־ʵ
};

#endif // LOGGER_H
